Presentation is loading. Please wait.

Presentation is loading. Please wait.

1 Pseudo-polynomial time algorithm (The concept and the terminology are important) Partition Problem: Input: Finite set A=(a 1, a 2, …, a n } and a size.

Similar presentations


Presentation on theme: "1 Pseudo-polynomial time algorithm (The concept and the terminology are important) Partition Problem: Input: Finite set A=(a 1, a 2, …, a n } and a size."— Presentation transcript:

1 1 Pseudo-polynomial time algorithm (The concept and the terminology are important) Partition Problem: Input: Finite set A=(a 1, a 2, …, a n } and a size s(a) (integer) for each a  A. Question: Is there a subset A’  A such that  a  A’ s(a) =  a  A –A’ s(a)? Theorem: Partition problem is NP-complete (Karp, 1972). An dynamic algorithm: For i  n and j  0.5  a  A s(a), define t(i, j) to be true if and only if there is a subset A i of {a 1, a 2, …, a i } such that  a  Ai s(a)=j. Formula: T(i,j)=true if and only if t(i-1, j)=true or t(i-1, j-s(a i ))=true.

2 2 Example i012345678910111213 1TTFFFFFFFFFFFF 2TTFFFFFFFTTFFF 3TTFFFTTFFTTFFF 4TTFTTTTFTTTFTT 5TTFTTTTFTTTTTT Figure 4.8 Table of t(i,j) for the instance of PARTITION for which A={a 1,a 2,a 3,a 4,a 5 }, s(a 1 )=1, s(a 2 )=9, s(a 3 )=5, s(a 4 )=3, and s(a 5 )=8. The answer for this instance is "yes", since t(5,13)=T, reflecting the fact that s(a 1 )+s(a 2 )+s(a 4 )=13=26/2. j

3 3 Backtracking i=n; W=B; if ( t(n, W)== false) then stop; While (i> 0 ) do { if (t(i, W) == true) { if (t(i-1, W)== true) then i=i-1; else { W=W-s(a i ); print “a i ” i=i-1; } }

4 4 Time complexity The algorithm takes at most O(nB) time to fill in the table, where (Each cell needs constant time to compute). Do we have a polynomial time algorithm to solve the Partition Problem and thus all NP-complete problems? –No. –O(nB) is not polynomial in terms of the input size. S(a i )=2 n =10000…0. (binary number of n+1 bits ). So B is at least O(2 n ). The input size is O(n 2 ) if there some a i with S(a i )=2 n. B is not polynomial in terms of n (input size) in general. However, if any upper bound is imposed on B, (e.g., B is Polynomial), the problem can be solved in polynomial time for this special case. (This is called pseudo-polynomial.)

5 5 0-1 version

6 6

7 7

8 8

9 9

10 10

11 11 Change-making problem: Given an amount n and unlimited quantities of coins of each of the denominations d 1, d 2, …, d m, find the smallest number of coins that add up to n or indicate that the problem does not have a solution. Solution: Let d(i) be the minimum number of coins used for amount i. Initial values: d(0)=0, d(i)= . equation: d(i) = min d(i-d k )+1. k=1, 2, …, m.

12 12 Change-making problem: Initial values: d(0)=0, d(i)= . equation: d(i) = min d(i-d k )+1 k=1, 2, …, m & i-d k ≥0 d 1 =2 and d 2 =5. i=7. i= 0, 1, 2, 3, 4, 5, 6, 7 d(i): 0, , 1, , 2, 1, 3, 2. Backtracking: $5, $2. (how do you get d(7)=2? d(7)=d(2)+5. Print $5 and goto d(2). How do you get d(2)? D(2)=2+d(0). Print out $2 and goto d(0). Whenever reach d(0), we stop. ) for i=3, since d(3)= , there is no solution.

13 13 More On Dynamic programming Algorithms Shortest path with edge constraint: Let G=(V, E) be a directed graph with weighted edges. Let s and v be two vertices in V. Find a shortest path from s to u with exactly k edges. Here k  n-1 is part of the input. Solution: Define d(i, v) be the length of the shortest path from s to v with exactly i edges. d(i, v)=min {c(w, v)+d(i-1, w)} w  V. Initial values: d(i, s)=0, for i=0, d(i,s)=  for i=1, 2, …, d(0, v)=  ; d(k, v) will give the length of the shortest path. A backtracking process can give the path.

14 14 0 6 7 9 2 5 -2 8 7 -3 -4 8 8 8 8 z uv xy i z, u, x, v, y 0 0     1  6z 7z   2   14u 4x 2u 3 4y 2v  9y 23x.

15 15 Exercise: Let T be a rooted binary tree, where each internal node in the tree has two children and every node (except the root) in T has a parent. Each leaf in the tree is assigned a letter in  ={A, C, G, T}. Figure 1 gives an example. Consider an edge e in T. Assume that every end of e is assigned a letter. The cost of e is 0 if the two letters are identical and the cost is 1 if the two letters are not identical. The problem here is to assign a letter in  to each internal node of T such that the cost of the tree is minimized, where the cost of the tree is the total cost of all edges in the tree. Design a polynomial-time dynamic programming algorithm to solve the problem.

16 16 A A C Figure 1 A

17 17 Assignment 4. (Due on Friday of Week 13. Drop it in Mail Box 71 or 72) This time, Sze Man Yuen and I can explain the questions, but we will NOT tell you how to solve the problems. Question 1. (30 points) Give a polynomial time algorithm to find the longest monotonically increasing subsequence of a sequence of n numbers. Your algorithm should use linear space. (10 points for linear space) (Assume that each integer appears once in the input sequence of n numbers) Example: Consider sequence 1,8, 2,9, 3,10, 4, 5. Both subsequences 1, 2, 3, 4, 5 and 1, 8, 9, 10 are monotonically increasing subsequences. However, 1,2,3, 4, 5 is the longest.

18 18 Assignment 4. Question 2. (30 points) Given an integer d and a sequence of integers s=s 1 s 2 …s n. Design a polynomial time algorithm to find the longest monotonically increasing subsequence of s such that the difference between any two consecutive numbers in the subsequence is at least d. Example: Consider the input sequence 1,7,8, 2,9, 3,10, 4, 5. The subsequence 1, 2, 3, 4, 5 is a monotonically increasing subsequence such that the difference between any two consecutive numbers in the subsequence is at least 1. 1, 3, 5 is a monotonically increasing subsequence such that the difference between any two consecutive numbers in the subsequence is at least 2.

19 19 Assignment 4. Question 3. (40 points). Suppose you have one machine and a set of n jobs a 1, a 2, …, a n to process on that machine. Each job a j has an integer processing time t j, a profit p j and an integer deadline d j. The machine can process only one job at a time, and job a j must run uninterruptedly for t j consecutive time units. If job a j is completed by its deadline d j, you receive a profit p j, but if it is completed after its deadline, you receive a profit of 0. Give a dynamic programming algorithm to find the schedule that obtains the maximum amount of profit. What is the running time of your algorithm? (Let d be the biggest deadline, the running time can be related to d. )


Download ppt "1 Pseudo-polynomial time algorithm (The concept and the terminology are important) Partition Problem: Input: Finite set A=(a 1, a 2, …, a n } and a size."

Similar presentations


Ads by Google